/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "acdefs.h"
#include "iferrmsg.h"


/* ARGSUSED */
int 
ACaskQuest(cktp,anal,which,value)

GENERIC *cktp;
GENERIC *anal;
int which;
IFvalue *value;
{
    ACAN *job = (ACAN *) anal;

    if (ACquery(&job->AC,which,value) == OK)
        return (OK);
    if (DCTquery(&job->DC,which,value) == OK)
        return (OK);
    return (E_BADPARM);
}


int 
ACquery(ac,which,value)

struct sACprms *ac;
int which;
IFvalue *value;
{
    switch (which) {

        case AC_START:
            value->rValue = ac->fstart;
            break;

        case AC_STOP:
            value->rValue = ac->fstop;
            break;

        case AC_STEPS:
            value->iValue = ac->numSteps;
            break;

        case AC_DEC:
            if (ac->stepType == DECADE) {
                value->iValue = 1;
            }
            else {
                value->iValue = 0;
            }
            break;

        case AC_OCT:
            if (ac->stepType == OCTAVE) {
                value->iValue = 1;
            }
            else {
                value->iValue = 0;
            }
            break;

        case AC_LIN:
            if (ac->stepType == LINEAR) {
                value->iValue = 1;
            }
            else {
                value->iValue = 0;
            }
            break;

        default:
            return (E_BADPARM);
    }
    return (OK);
}
