/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "dctdefs.h"
#include "iferrmsg.h"


/* ARGSUSED */
int 
DCTaskQuest(cktp,anal,which,value)

GENERIC *cktp;
GENERIC *anal;
int which;
IFvalue *value;
{
    DCTAN *job = (DCTAN *) anal;

    if (DCTquery(&job->DC,which,value) == OK)
        return (OK);
    return (E_BADPARM);
}


int 
DCTquery(dc,which,value)

struct sDCTprms *dc;
int which;
IFvalue *value;
{
    switch (which) {

        case DC_NAME1:
            value->uValue = dc->eltName[0];
            break;

        case DC_START1:
            value->rValue = dc->vstart[0];
            break;

        case DC_STOP1:
            value->rValue = dc->vstop[0];
            break;

        case DC_STEP1:
            value->rValue = dc->vstep[0];
            break;

        case DC_NAME2:
            value->uValue = dc->eltName[1];
            break;

        case DC_START2:
            value->rValue = dc->vstart[1];
            break;

        case DC_STOP2:
            value->rValue = dc->vstop[1];
            break;

        case DC_STEP2:
            value->rValue = dc->vstep[1];
            break;

        default:
            return (E_BADPARM);
    }
    return (OK);
}
