/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1988 Jaijeet S Roychowdhury
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <math.h>
#include "cktdefs.h"
#include "distodef.h"
#include "sperror.h"
#include "distoext.h"

int
DkerProc(type,rPtr,iPtr,size,job)

double *rPtr;
double *iPtr;
int size;
DISTOAN* job;
int type;
{
    int i;
    double temp;

    switch(type) {

        case D_F1:

            for (i = 1; i <= size; i++) {
                iPtr[i] *= 2.0; /* convert to sinusoid amplitude */
                rPtr[i] *= 2.0;
            }
            break;

        case D_F2:

            for (i = 1; i <= size; i++) {
                rPtr[i] *= 2.0;
                iPtr[i] *= 2.0;
            }
            break;

        case D_TWOF1:
    
            for (i = 1; i <= size; i++) {
                iPtr[i] *= 2.0;
                rPtr[i] *= 2.0;
            }
            break;

        case D_THRF1:

            for (i = 1; i <= size; i++) {
                iPtr[i] *= 2.0;
                rPtr[i] *= 2.0;
            }
            break;

        case D_F1PF2:

            for (i = 1; i <= size; i++) {
                iPtr[i] *= 4.0;
                rPtr[i] *= 4.0;
            }
            break;

        case D_F1MF2:
    
            for (i = 1; i <= size; i++) {
                iPtr[i] *= 4.0;
                rPtr[i] *= 4.0;
            }
            break;

        case D_2F1MF2:

            for (i = 1; i <= size; i++) {
                iPtr[i] *= 6.0;
                rPtr[i] *= 6.0;
            }
            break;

        default:

            return (E_BADPARM);

    }
    return (OK);
}
