/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1987 Gary W. Ng
         1992 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "noisedef.h"
#include "iferrmsg.h"


int 
NOISEaskQuest(cktp,anal,which,value)

GENERIC *cktp;
GENERIC *anal;
int which;
IFvalue *value;
{
    NOISEAN *job = (NOISEAN *) anal;

    switch (which) {

        case N_OUTPUT:
            value->sValue = job->Noutput;
            break;

        case N_OUTREF:
            value->sValue = job->NoutputRef;
            break;

        case N_INPUT:
            value->sValue = job->Ninput;
            break;

        case N_PTSPERSUM:
            value->iValue = job->NStpsSm;
            break;

        default:
            if (ACquery(&job->AC,which,value) == OK)
                return (OK);
            if (DCTquery(&job->DC,which,value) == OK)
                return (OK);
            return (E_BADPARM);
    }
    return (OK);
}

