/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1987 Thomas L. Quarles
         1992 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include "ftedefs.h"
#include "inpdefs.h"
#include "inpmacs.h"
#include "misc.h"

/* ARGSUSED */
int
OPTparse(ckt,tab,which,currentp,line,task,gnode)

/* .options parm=xxx ... */
GENERIC *ckt;
INPtables *tab;
int which;
GENERIC *currentp;
char **line;
GENERIC *task;
GENERIC *gnode;
{
    GENERIC *foo;   /* pointer to analysis */
    IFparm *prm;    /* pointer to parameter to search through array */
    char *token;    /* a token from the line */
    IFvalue *parm;  /* a pointer to a value struct for function returns */
    int error;      /* error code temporary */
    int i;          /* generic loop variable */
    char errbuf[BSIZE_SP];
    card *current = (card *)currentp;

    prm = ft_sim->analyses[which]->analysisParms;
    while (**line) {
        INPgetTok(line,&token,1);
        for (i = 0; i < ft_sim->analyses[which]->numParms; i++) {
            if (strcmp(token,prm[i].keyword))
                continue;

            if (!(prm[i].dataType & IF_UNIMP_MASK)) {
                /*
                (void) sprintf(errbuf,
                    "%s not yet implemented - ignored",token);
                LITERR(errbuf)
                */
                parm = INPgetValue(ckt,line, prm[i].dataType, tab);
                break;
            }
            if (prm[i].dataType & IF_SET) {
                parm = INPgetValue(ckt,line,
                    prm[i].dataType & IF_VARTYPES, tab);
                error = (*(ft_sim->setAnalysisParm))(ckt,
                    ft_curckt->ci_curOpt,prm[i].id,parm,(IFvalue*)NULL);
                if (error) {
                    (void) sprintf(errbuf, "Can't set option %s", token);
                    LITERR(errbuf)
                }
                break;
            }
        }
        if (i == ft_sim->analyses[which]->numParms) {
            (void) sprintf(errbuf, "Unknown option %s - ignored",token);
            LITERR(errbuf)
        }
        txfree(token);
    }
    return (0);
}
