/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "suffix.h"
#include <stdio.h>
#include "cktdefs.h"
#include "pzdefs.h"
#include "iferrmsg.h"
#include "cktext.h"


/* ARGSUSED */
int 
PZaskQuest(cktp,anal,which,value)

GENERIC *cktp;
GENERIC *anal;
int which;
IFvalue *value;
{
    CKTcircuit *ckt = (CKTcircuit *)cktp;

    switch (which) {

        case PZ_NODEI:
            value->nValue = (IFnode)CKTnum2nod(ckt,((PZAN*)anal)->PZin_pos);
            break;

        case PZ_NODEG:
            value->nValue = (IFnode)CKTnum2nod(ckt,((PZAN*)anal)->PZin_neg);
            break;

        case PZ_NODEJ:
            value->nValue = (IFnode)CKTnum2nod(ckt,((PZAN*)anal)->PZout_pos);
            break;

        case PZ_NODEK:
            value->nValue = (IFnode)CKTnum2nod(ckt,((PZAN*)anal)->PZout_neg);
            break;

        case PZ_V:
            if ( ((PZAN*)anal)->PZinput_type == PZ_IN_VOL) {
                value->iValue=1;
            }
            else {
                value->iValue=0;
            }
            break;

        case PZ_I:
            if ( ((PZAN*)anal)->PZinput_type == PZ_IN_CUR) {
                value->iValue=1;
            }
            else {
                value->iValue=0;
            }
            break;

        case PZ_POL:
            if ( ((PZAN*)anal)->PZwhich == PZ_DO_POLES) {
                value->iValue=1;
            }
            else {
                value->iValue=0;
            }
            break;

        case PZ_ZER:
            if ( ((PZAN*)anal)->PZwhich == PZ_DO_ZEROS) {
                value->iValue=1;
            }
            else {
                value->iValue=0;
            }
            break;

        case PZ_PZ:
            if ( ((PZAN*)anal)->PZwhich == PZ_DO_POLES | PZ_DO_ZEROS) {
                value->iValue=1;
            }
            else {
                value->iValue=0;
            }
            break;

        default:
            return (E_BADPARM);
    }
    return (OK);
}
