/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1987 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include "ftedefs.h"
#include "inpdefs.h"
#include "inpmacs.h"
#include "misc.h"


/* ARGSUSED */
int
PZparse(ckt,tab,which,currentp,line,task,gnode)

/* .pz nodeI nodeG nodeJ nodeK {V I} {POL ZER PZ} */
GENERIC *ckt;
INPtables *tab;
int which;
GENERIC *currentp;
char **line;
GENERIC *task;
GENERIC *gnode;
{
    char *steptype; /* type of stepping function */
    GENERIC *foo;   /* pointer to analysis */
    IFvalue ptemp;  /* a value structure to package stuff into */
    IFvalue *parm;  /* a pointer to a value struct for function returns */
    int error;      /* error code temporary */
    card *current = (card *)currentp;

    IFC(newAnalysis,(ckt,which,"pole-zero analysis",&foo, task))

    parm = INPgetValue(ckt,line,IF_NODE,tab); 
    GCA(INPapName,(ckt,which,foo,"nodei",parm))

    parm = INPgetValue(ckt,line,IF_NODE,tab); 
    GCA(INPapName,(ckt,which,foo,"nodeg",parm))

    parm = INPgetValue(ckt,line,IF_NODE,tab); 
    GCA(INPapName,(ckt,which,foo,"nodej",parm))

    parm = INPgetValue(ckt,line,IF_NODE,tab); 
    GCA(INPapName,(ckt,which,foo,"nodek",parm))

    INPgetTok(line,&steptype,1); /* get V or I */
    steptype[1] = '\0';
    strtolower(steptype);
    if (*steptype == 'c')  /* recognize "cur" */
        *steptype = 'i';
    ptemp.iValue = 1;
    GCA(INPapName,(ckt,which,foo,steptype,&ptemp))
    txfree(steptype);

    INPgetTok(line,&steptype,1); /* get POL, ZER, or PZ */
    steptype[3] = '\0';  /* "pole", "zero" OK */
    strtolower(steptype);
    ptemp.iValue = 1;
    GCA(INPapName,(ckt,which,foo,steptype,&ptemp))
    txfree(steptype);

    return (0);
}
