/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: UCB CAD Group
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include "iferrmsg.h"
#include "cktdefs.h"
#include "sensdefs.h"


/* ARGSUSED */
int 
SENSaskQuest(cktp,anal,which,value)

GENERIC *cktp;
GENERIC *anal;
int which;
IFvalue *value;
{
    SENSAN *job = (SENSAN *) anal;

    switch (which) {

        case SENS_DEFTOL:
            value->rValue = job->SENSdefTol;
            break;

        case SENS_DEFPERTURB:
            value->rValue = job->SENSdefPert;
            break;

        case SENS_POS:
            value->nValue = (IFnode)job->SENSoutPos;
            break;

        case SENS_NEG:
            value->nValue = (IFnode)job->SENSoutNeg;
            break;

        case SENS_SRC:
            value->uValue = job->SENSoutSrc;
            break;

        case SENS_NAME:
            value->sValue = job->SENSoutName;
            break;

        default:
            if (ACquery(&job->AC,which,value) == OK)
                return (OK);
            if (DCTquery(&job->DC,which,value) == OK)
                return (OK);
            return (E_BADPARM);
    }
    return (OK);
}

