/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "tfdefs.h"
#include "iferrmsg.h"


/* ARGSUSED */
int 
TFaskQuest(cktp,anal,which,value)

GENERIC *cktp;
GENERIC *anal;
int which;
IFvalue *value;
{
    TFAN *job = (TFAN *) anal;

    switch (which) {

        case TF_OUTPOS:
            value->nValue = (IFnode)job->TFoutPos;
            break;

        case TF_OUTNEG:
            value->nValue = (IFnode)job->TFoutNeg;
            break;

        case TF_OUTNAME:
            value->sValue = job->TFoutName;
            break;

        case TF_OUTSRC:
            value->uValue = job->TFoutSrc;
            break;

        case TF_INSRC:
            value->uValue = job->TFinSrc;
            break;

        default:
            if (ACquery(&job->AC,which,value) == OK)
                return (OK);
            if (DCTquery(&job->DC,which,value) == OK)
                return (OK);
            return (E_BADPARM);
    }
    return (OK);
}

