/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "trandefs.h"
#include "iferrmsg.h"


/* ARGSUSED */
int 
TRANaskQuest(cktp,anal,which,value)

GENERIC *cktp;
GENERIC *anal;
int which;
IFvalue *value;
{
    TRANAN *job = (TRANAN *) anal;

    switch (which) {

        case TRAN_TSTOP:
            value->rValue = job->TRANfinalTime;
            break;

        case TRAN_TSTEP:
            value->rValue = job->TRANstep;
            break;

        case TRAN_TSTART:
            value->rValue = job->TRANinitTime;
            break;

        case TRAN_TMAX:
            value->rValue = job->TRANmaxStep;
            break;

        case TRAN_UIC:
            if (job->TRANmode & MODEUIC) {
                value->iValue = 1;
            }
            else {
                value->iValue = 0;
            }
            break;

        default:
            if (DCTquery(&job->DC,which,value) == OK)
                return (OK);
            return (E_BADPARM);
    }
    return (OK);
}

