/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/


#include "spice.h"
#include <stdio.h>
#include "devdefs.h"
#include "sperror.h"
#include "util.h"
#include "cktext.h"


int
CKTaccept(ckt)

/* 
 * this is a driver program to iterate through all the various
 * accept functions provided for the circuit elements in the
 * given circuit 
 */
CKTcircuit *ckt;
{
    extern SPICEdev *DEVices[];
    int i;
    int size;
    int error;
    double *temp;
    struct sCKTmodHead *mh;
    int (*func)();

    for (mh = ckt->CKTheadList; mh != NULL; mh = mh->next) {
        if ((func = DEVices[mh->type]->DEVaccept) != NULL) {
            error = (*func)(ckt,mh->head);
            if (error) return (error);
        }
    }

    /* now, move the sols vectors around */
    temp = ckt->CKTsols[7];
    for (i = 7; i > 0; i--) {
        ckt->CKTsols[i] = ckt->CKTsols[i-1];
    }
    ckt->CKTsols[0] = temp;
    size = spGetSize(ckt->CKTmatrix,1);
    /* CKTrhsOld contains the last solution */
    for (i = 0; i <= size; i++) {
        ckt->CKTsols[0][i] = ckt->CKTrhsOld[i];
    }
    return (OK);
}
