/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /*
     * CKTaskNodQst
     *
     *   ask about a parameter on a node.
     */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "iferrmsg.h"
#include "util.h"
#include "cktext.h"


/* ARGSUSED */
int
CKTaskNodQst(ckt,node,parm,value,selector)

GENERIC *ckt;
GENERIC *node;
int parm;
IFvalue *value;
IFvalue *selector;
{
    if (!node) return (E_BADPARM);

    switch (parm) {

        case PARM_NS:
            value->rValue = ((CKTnode *)node)->nodeset;
            break;

        case PARM_IC:
            value->rValue = ((CKTnode *)node)->ic;
            break;

        case PARM_NODETYPE:
            value->iValue = ((CKTnode *)node)->type;
            break;

        default:
            return (E_BADPARM);
    }
    return (OK);
}
