/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

/* CKTbindNode
 *  bind a node of the specified device of the given type to its place
 *  in the specified circuit.
 */

#include "spice.h"
#include <stdio.h>
#include "devdefs.h"
#include "sperror.h"
#include "util.h"
#include "cktext.h"

extern SPICEdev *DEVices[];

/*ARGSUSED*/
int
CKTbindNode(ckt,fast,term,node)

GENERIC *ckt;
GENERIC *fast;
int term;
GENERIC *node;
{
    int i, mappednode;
    int type = ((GENinstance *)fast)->GENmodPtr->GENmodType;
    char key = *(char*)((GENinstance *)fast)->GENname;
    IFkeys *keys = DEVices[type]->DEVpublic.keys;

    for (i = 0; i < *DEVices[type]->DEVpublic.numKeys; i++) {
        if (keys[i].key == key)
            break;
    }
    if (i == *DEVices[type]->DEVpublic.numKeys)
        return (E_NOTERM);

    mappednode = ((CKTnode *)node)->number;

    if (keys[i].numTerms >= term && term > 0) {
        switch (term) {
            default:
                return (E_NOTERM);
            case 1:
                ((GENinstance *)fast)->GENnode1 = mappednode;
                break;
            case 2:
                ((GENinstance *)fast)->GENnode2 = mappednode;
                break;
            case 3:
                ((GENinstance *)fast)->GENnode3 = mappednode;
                break;
            case 4:
                ((GENinstance *)fast)->GENnode4 = mappednode;
                break;
            case 5:
                ((GENinstance *)fast)->GENnode5 = mappednode;
                break;
        }
        return (OK);
    }
    return (E_NOTERM);
}
