/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /* CKTfndBranch(ckt,name)
     * this is a driver program to iterate through all the various
     * findBranch functions provided for the circuit elements in the
     * given circuit 
     */

#include "spice.h"
#include <stdio.h>
#include "devdefs.h"
#include "cktext.h"


int
CKTfndBranch(ckt,name)

CKTcircuit *ckt;
IFuid name;
{
    extern SPICEdev *DEVices[];

    int j;
    struct sCKTmodHead *mh;
    int (*func)();

    for (mh = ckt->CKTheadList; mh != NULL; mh = mh->next) {
        if ((func = DEVices[mh->type]->DEVfindBranch) != NULL) {
            j = (*func)(ckt,mh->head,name);
            if (j != 0) return (j);
        }
    }
    return (0);
}
