/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1992 Stephen R. Whiteley
****************************************************************************/

/* CKTfndAnal
 *  find the given Analysis given its name and return the Analysis pointer
 */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "jobdefs.h"
#include "tskdefs.h"
#include "sperror.h"
#include "cktext.h"


/* ARGSUSED */
int
CKTfndAnal(ckt,numjobs,anal,name,inTask,taskName)

GENERIC *ckt;
int *numjobs;
GENERIC **anal;
IFuid name;
GENERIC *inTask;
IFuid taskName;
{
    TSKtask *task = (TSKtask *)inTask;
    JOB *here;

    for (here = task->jobs; here; here = here->JOBnextJob) {

        if (!name && here->JOBname) {
            if (numjobs) {
                *numjobs = 0;
                for ( ; here; here = here->JOBnextJob)
                    (*numjobs)++;
            }
            return (OK);
        }

        if (strcmp(here->JOBname,name) == 0) {
            if (anal) *anal = (GENERIC *)here;
            return (OK);
        }
    }
    return (E_NOTFOUND);
}
