/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /* CKTinst2Node
     *  get the name and node pointer for a node given a device it is
     * bound to and the terminal of the device.
     */

#include "spice.h"
#include <stdio.h>
#include "devdefs.h"
#include "sperror.h"
#include "cktext.h"


extern SPICEdev *DEVices[];

int
CKTinst2Node(ckt,instPtr,term,node,nodeName)

GENERIC *ckt;
GENERIC *instPtr;
int term;
GENERIC **node;
IFuid *nodeName;
{
    int i, nodenum;
    CKTnode *here;
    int type = ((GENinstance *)instPtr)->GENmodPtr->GENmodType;
    char key = *(char*)((GENinstance *)instPtr)->GENname;
    IFkeys *keys = DEVices[type]->DEVpublic.keys;

    for (i = 0; i < *DEVices[type]->DEVpublic.numKeys; i++) {
        if (keys[i].key == key)
            break;
    }
    if (i == *DEVices[type]->DEVpublic.numKeys)
        return (E_NOTERM);

    if (keys[i].numTerms >= term && term > 0) {
        switch (term) {
            default:
                return (E_NOTERM);
            case 1:
                nodenum = ((GENinstance *)instPtr)->GENnode1;
                break;
            case 2:
                nodenum = ((GENinstance *)instPtr)->GENnode2;
                break;
            case 3:
                nodenum = ((GENinstance *)instPtr)->GENnode3;
                break;
            case 4:
                nodenum = ((GENinstance *)instPtr)->GENnode4;
                break;
            case 5:
                nodenum = ((GENinstance *)instPtr)->GENnode5;
                break;
        }
        /* ok, now we know its number, so we just have to find it.*/
        for (here = ((CKTcircuit*)ckt)->CKTnodes; here; here = here->next) {
            if (here->number == nodenum) {
                /* found it */
                *node = (GENERIC*) here;
                *nodeName = here->name;
                return (OK);
            }
        }
        return (E_NOTFOUND);
    }
    return (E_NOTERM);
}
