/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include <math.h>
#include "sperror.h"
#include "util.h"
#include "devdefs.h"

extern SPICEdev *DEVices[];


int
CKTic(ckt)

CKTcircuit *ckt;
{
    int i, error, size;
    CKTnode *node;

    size = spGetSize(ckt->CKTmatrix,1);
    for (i = 0; i <= size; i++) {
        *(ckt->CKTrhs + i) = 0;
    }
    for (node = ckt->CKTnodes; node != NULL; node = node->next) {
        if (node->nsGiven) {
            node->ptr =
                spGetElement(ckt->CKTmatrix,node->number,node->number);
            if (node->ptr == (double *)NULL)
                return (E_NOMEM);
            ckt->CKThadNodeset = 1;
            *(ckt->CKTrhs + node->number) = node->nodeset;
        }
        if (node->icGiven) {
            if (!( node->ptr)) {
                node->ptr =
                    spGetElement(ckt->CKTmatrix,node->number,node->number);
                if (node->ptr == (double *)NULL)
                    return (E_NOMEM);
            }
            *(ckt->CKTrhs + node->number) = node->ic;
        }
    }
    return (OK);
}


int
CKTsetic(ckt)

CKTcircuit *ckt;
{
    struct sCKTmodHead *mh;
    int (*func)();
    int error;

    for (mh = ckt->CKTheadList; mh != NULL; mh = mh->next) {
        if ((func = DEVices[mh->type]->DEVsetic) != NULL) {
            error = (*func)(mh->head,ckt);
            if (error)
                return (error);
        }
    }
    return (OK);
}
    
