/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /* CKTmodParam
     *  attach the given parameter to the specified model in the given circuit
     */

#include "spice.h"
#include <stdio.h>
#include "devdefs.h"
#include "sperror.h"
#include "util.h"
#include "cktext.h"


extern SPICEdev *DEVices[];

/* ARGSUSED */
int
CKTmodParam(ckt,modfast,param,val,selector)

GENERIC *ckt;
GENERIC *modfast;
int param;
IFvalue *val;
IFvalue *selector;
{
    int type = ((GENmodel *)modfast)->GENmodType;

    if (DEVices[type]->DEVmodParam) {
        return ( (*DEVices[type]->DEVmodParam)(param,val,
                (GENmodel *)modfast) );
    }
    else {
        return (E_BADPARM);
    }
}
