/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /*
     * CKTnames(ckt)
     *  output information on all circuit nodes/equations
     *
     */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "iferrmsg.h"
#include "util.h"
#include "cktext.h"


int
CKTnames(ckt,numNames,nameList)

CKTcircuit *ckt;
int *numNames;
IFuid **nameList;
{
    CKTnode *here;
    int i;
    *numNames = ckt->CKTmaxEqNum - 1;
    *nameList = (IFuid *)MALLOC(*numNames * sizeof(IFuid));
    if ((*nameList) == (IFuid *)NULL) return (E_NOMEM);
    i = 0;
    for (here = ckt->CKTnodes->next; here; here = here->next)  {
        *((*nameList) + i++) = here->name;
    }
    return (OK);
}
