/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /*
     * CKTnewEq(ckt,node,name)
     *  Allocate a new circuit equation number (returned) in the specified
     *  circuit to contain a new equation or node
     * returns -1 for failure to allocate a node number 
     *
     */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "iferrmsg.h"
#include "util.h"
#include "cktext.h"


int
CKTnewEq(inCkt,node,name)

GENERIC *inCkt;
GENERIC **node;
IFuid name;
{
    CKTnode *mynode;
    CKTcircuit *ckt = (CKTcircuit *)inCkt;
    int error;

    error = CKTmkNode(ckt,&mynode);
    if (error) return (error);

    if (node) *node = (GENERIC *)mynode;
    mynode->name = name;

    error = CKTlinkEq(ckt,mynode);

    return (error);
}
