/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Wayne A. Christopher
         1993 Stephen R. Whiteley
****************************************************************************/


#include "spice.h"
#include <stdio.h>
#include "devdefs.h"
#include "sperror.h"
#include "util.h"
#include "cktext.h"

extern SPICEdev *DEVices[];


int
CKTparam(ckt,fast,param,val,selector)

/*
 *  attach the given parameter to the specified device in the given circuit
 */
GENERIC *ckt;
GENERIC *fast;
int param;
IFvalue *val;
IFvalue *selector;
{
    int type;
    GENinstance *myfast = (GENinstance *)fast;

    type = myfast->GENmodPtr->GENmodType;

    if (DEVices[type]->DEVparam) {
        return ( (*DEVices[type]->DEVparam)
            (ckt,param,val,myfast,selector) );
    }
    else {
        return (E_BADPARM);
    }
}
