/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /*
     * CKTsetNodPm
     *
     *   set a parameter on a node.
     */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "iferrmsg.h"
#include "util.h"
#include "cktext.h"


/* ARGSUSED */
int
CKTsetNodPm(ckt,node,parm,value,selector)

GENERIC *ckt;
GENERIC *node;
int parm;
IFvalue *value;
IFvalue *selector;
{
    if (!node) return (E_BADPARM);

    switch (parm) {

        case PARM_NS:
            ((CKTnode *)node)->nodeset = value->rValue;
            ((CKTnode *)node)->nsGiven = 1;
            break;

        case PARM_IC:
            ((CKTnode *)node)->ic = value->rValue;
            ((CKTnode *)node)->icGiven = 1;
            break;

        case PARM_NODETYPE:
            ((CKTnode *)node)->type = value->iValue;
            break;

        default:
            return (E_BADPARM);
    }
    return (OK);
}
