/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

    /* CKTtemp(ckt)
     * this is a driver program to iterate through all the various
     * temperature dependency functions provided for the circuit 
     * elements in the given circuit 
     */

#include "spice.h"
#include <stdio.h>
#include "devdefs.h"
#include "const.h"
#include "sperror.h"
#include "cktext.h"


extern SPICEdev *DEVices[];

int
CKTtemp(ckt)

CKTcircuit *ckt;
{
    int error;
    struct sCKTmodHead *mh;
    int (*func)();

    ckt->CKTvt = CONSTKoverQ * ckt->CKTtemp;

    for (mh = ckt->CKTheadList; mh != NULL; mh = mh->next) {
        if ((func = DEVices[mh->type]->DEVtemperature) != NULL) {
            error = (*func)(mh->head,ckt);
            if (error) return (error);
        }
    }
    return (OK);
}
