/***************************************************************************
JSPICE3 adaptation of Spice3f2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

/*  look up the 'type' in the device description struct and return the
 *  appropriate index for the device found, or -1 for not found 
 */

#include "spice.h"
#include "devdefs.h"
#include "cktext.h"


extern SPICEdev *DEVices[];

int
CKTtypelook(type)

char *type;
{
    int i;

    for (i = 0; i < DEVmaxnum; i++) {
        if (strcmp(type,DEVices[i]->DEVpublic.name) == 0) {
            /*found the device - return it */
            return (i);
        }
    }
    return (-1);
}

