/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Wayne A. Christopher
         1992 Stephen R. Whiteley
****************************************************************************/

/*
 * Various things for quoting words. If this is not ascii, quote and
 * strip are no-ops, so '' and \ quoting won't work. To fix this, sell
 * your IBM machine.
 */

#include "spice.h"
#include "cpdefs.h"
#include "suffix.h"


/* Strip all the 8th bits from a string (destructively). */

void
cp_wstrip(str)

char *str;
{
    if (str)
        while (*str) {
            *str = strip(*str);
            str++;
        }
    return;
}


/* Quote all characters in a word. */

void
cp_quoteword(str)

char *str;
{
    if (str)
        while (*str) {
            *str = quote(*str);
            str++;
        }
    return;
}


/* Print a word (strip the word first). */

void
cp_printword(string, fp)

char *string;
FILE *fp;
{
    char *s;

    if (string)
        for (s = string; *s; s++)
            (void) putc((strip(*s)), fp);
    return;
}


/* (Destructively) strip all the words in a wlist. */

void
cp_striplist(wlist)

wordlist *wlist;
{
    wordlist *wl;

    for (wl = wlist; wl; wl = wl->wl_next)
        cp_wstrip(wl->wl_word);
    return;
}


/* Remove the "" from a string. */

void
cp_unquote(string)

char *string;
{
    char *s;
    int l;

    if (string == NULL) return;
    s = string;
    if (*s == '"')
        while (*s) {
            *(s) = *(s+1);
            s++;
        }
    l = strlen(string) - 1;

    if (string[l] == '"')
        string[l] = '\0';

    return;
}
