/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1992 Stephen R. Whiteley
****************************************************************************/

#include "mfb.h"
#include "mfbp.h"

#define RadToDeg    57.29577951

void
MFBArc(x,y,r,astart,astop,s)

int x;      /* x coordinate of center */
int y;      /* y coordinate of center */
int r;      /* radius of arc */
int astart; /* initial angle ( +x axis = 0 degrees ) */
int astop;  /* final angle ( +x axis = 0 degrees ) */
int s;      /* number of segments in a 360 degree arc */
/*
 * Notes:
 *    Draws an arc of radius r and center at (x,y) beginning at
 *    angle astart (in degrees) and ending at astop
 */

{
    int i,j;
    double d = astart / RadToDeg;

    MFBMoveTo(x + (int)(r * cos(d)),y + (int)(r * sin(d)));

    while (astart >= astop)
        astop += 360;

    if (s <= 2 || s > 180)
        s = 18;

    j = (astop - astart)/s;

    if (!j)
        j++;

    for (i = astart + j; i <= astop; i += j) {
        d = i / RadToDeg;
        MFBDrawLineTo(x + (int)(r * cos(d)), y + (int)(r * sin(d)));
    }
    d = astop / RadToDeg;
    MFBDrawLineTo(x + (int)(r * cos(d)), y + (int)(r * sin(d)));
}
