/*************************************************************************
 MFB graphics and miscellaneous library
 Copyright (c) Stephen R. Whiteley 1992
 Author: Stephen R. Whiteley
 *************************************************************************/

#include "mfb.h"
#include "mfbP.h"

static struct errinfo {
    int er_num;
    char *er_string;
} errstrings[] = {
    { MFBOK,            "Operation completed successfully" } ,
    { MFBBADENT,        "Unknown terminal type" } ,
    { MFBBADMCF,        "Can't open mfbcap file" } ,
    { MFBMCELNG,        "Mfbcap entry too long" } ,
    { MFBBADMCE,        "Bad mfbcap entry" } ,
    { MFBINFMCE,        "Infinite mfbcap entry" } ,
    { MFBBADTTY,        "stdout not in /dev" } ,
    { MFBBADLST,        "Illegal line style" } ,
    { MFBBADFST,        "Illegal fill style" } ,
    { MFBBADCST,        "Illegal color style" } ,
    { MFBBADTM1,        "No destructive text mode" } ,
    { MFBBADTM2,        "No overstrike text mode" } ,
    { MFBNODFLP,        "No definable line styles" } ,
    { MFBNODFFP,        "No definable fill styles" } ,
    { MFBNODFCO,        "No definable colors" } ,
    { MFBNOBLNK,        "No blinkers" } ,
    { MFBBADDEV,        "Can't open or close device" } ,
    { MFBBADOPT,        "Can't access or set device status" } ,
    { MFBNOMASK,        "No definable read or write mask" } ,
    { MFBBADWRT,        "Error in write" } ,
    { MFBPNTERR,        "Error in pointing device" } ,
    { MFBNOPTFT,        "No format for pointing device" } ,
    { MFBNOPNT,         "No pointing device" } ,
    { MFBNORBND,        "No rubberbanding" } ,
    { MFBBADALU,        "Cannot set ALU mode" } ,
    { MFBNOMEM,         "Out of memory" } ,
    { 0,                NULL }
} ;


char *
MFBError(num)

int num;
{
    struct errinfo *ei;
    static char buf[32];

    for (ei = errstrings; ei->er_string; ei++)
        if (ei->er_num == num)
            break;
    if (ei->er_string)
        return (ei->er_string);
    else {
        sprintf(buf, "Unknown error # %d", num);
        return (buf);
    }
}
