/*************************************************************************
 MFB graphics and miscellaneous library
 Copyright (c) Stephen R. Whiteley 1992
 Author: Stephen R. Whiteley
 *************************************************************************/

#include "mfb.h"
#include "mfbP.h"
#include <dos.h>

#ifdef __STDC__
static void mode_1_flood(void);
static void mode_2_flood(void);
#else
static void mode_1_flood();
static void mode_2_flood();
#endif


void
MFBFlood()
{
    if (pc.mfbMODE & 2)
        mode_2_flood();
    else
        mode_1_flood();
}


static void
mode_1_flood()

{
    int alu;
    long i;
    vidmptr rgen;

    outpw(0x3ce,0xff08); /* set bit mask */
    outpw(0x3ce,0x0205); /* write mode 2 */
    outpw(0x3ce,0x3);    /* set alu mode */
    rgen = pc.base;
    for (i = (long)pc.ysize*pc.bytpline; i; i--)
        *rgen++ = pc.curcolor;
    outpw(0x3ce,0x5);    /* write mode 1 */
}


#ifndef __GNUC__


static void
mode_2_flood()

{
    union { unsigned short o[2]; long l; } p;
    int i;
    unsigned j;
    unsigned color2;

    outpw(0x3ce,0xff08); /* set bit mask */
    outpw(0x3ce,0x3);    /* set alu mode */

    color2 = (pc.curcolor << 8) | pc.curcolor;
    p.l = (long) pc.ysize*pc.xsize;
    for (i = 0; i <= p.o[1]; i++) {
        outp(0x3cd,i);
        for (j = 0; j < (unsigned)0x8000; j++)
            *(((short far *)pc.base) + j) = color2;
    }
}


#else


static void
mode_2_flood()

{
    int j;
    unsigned color2;
    short *rgen;

    outpw(0x3ce,0xff08); /* set bit mask */
    outpw(0x3ce,0x3);    /* set alu mode */

    color2 = (pc.curcolor << 8) | pc.curcolor;
    j = ((long) pc.ysize*pc.xsize) >> 1;
    rgen = (short*)pc.base;
    while (j--) {
        *rgen++ = color2;
    }
}

#endif
