/*************************************************************************
 MFB graphics and miscellaneous library
 Copyright (c) Stephen R. Whiteley 1992
 Author: Stephen R. Whiteley
 *************************************************************************/

#include "mfb.h"
#include "mfbP.h"
#include <dos.h>

#ifdef __STDC__
static void mode_1_pixel(int,int);
static void mode_2_pixel(int,int);
#else
static void mode_1_pixel();
static void mode_2_pixel();
#endif


void
MFBPixel(x,y)

int x,y;
{
    if (pc.mfbMODE & 2)
        mode_2_pixel(x,y);
    else
        mode_1_pixel(x,y);
}


static void
mode_1_pixel(x,y)

int x, y;
{
    outpw(0x3ce,pc.curcolor << 8);
    outpw(0x3ce,0x0f01);
    outpw(0x3ce,pc.alumode); /* set alu mode */
    outpw(0x3ce,(0x80 >> (x & 7)) << 8 | 8);

    *(pc.base + ((x >> 3) + (pc.ysize-1-y)*pc.bytpline)) |= 1;

    outp(0x3cf,0xff);
    outpw(0x3ce,0x1);
}


#ifndef __GNUC__


static void
mode_2_pixel(x,y)

int x, y;
{
    union { unsigned short o[2]; long l; } p;

    outpw(0x3ce,0xff08); /* set bit mask */
    outpw(0x3ce,pc.alumode); /* set alu mode */
    p.l = x + (long) (pc.ysize-1-y)*pc.xsize;
    outp(0x3cd,p.o[1]);
    if (pc.alumode != 3)
        mfb_trash = *(pc.base + p.o[0]);
    *(pc.base + p.o[0]) = pc.curcolor;
}


#else


static void
mode_2_pixel(x,y)

int x, y;
{
    vidmptr rgen;

    rgen = pc.base + x + (long) (pc.ysize-1-y)*pc.xsize;
    if (rgen < pc.base)
        return;
    outpw(0x3ce,0xff08); /* set bit mask */
    outpw(0x3ce,pc.alumode); /* set alu mode */
    if (pc.alumode != 3)
        mfb_trash = *rgen;
    *rgen = pc.curcolor;
}

#endif
