/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1987 Jeffery M. Hsu
         1992 Stephen R. Whiteley
****************************************************************************/

/*
 * This file contains the routines to evalute arguments to a command
 * and prompt the user if necessary.
 */

#include "spice.h"
#include "ftedefs.h"
#include "scedio.h"

#define MAXPROMPT 1024
static char buf[MAXPROMPT];

#ifdef __STDC__
static int  countargs(wordlist*);
static void common(char*,wordlist*,struct comm*);
#else
static int  countargs();
static void common( );
#endif


static int
countargs(wl)

wordlist *wl;
{

    int number=0;
    wordlist *w;

    for (w = wl; w; w = w->wl_next) {
      number++ ;
    }
    return(number);

}


arg_print(wl, command)
wordlist *wl;
struct comm *command;
{

    common("which variable", wl, command);

}

arg_plot(wl, command)
wordlist *wl;
struct comm *command;
{

    common("which variable", wl, command);

}

arg_load(wl, command)
wordlist *wl;
struct comm *command;
{
      /* just call com_load */
      (*command->co_func) (wl);

}

arg_let(wl, command)
wordlist *wl;
struct comm *command;
{

    common("which vector", wl, command);

}

arg_set(wl, command)
wordlist *wl;
struct comm *command;
{

    common("which variable", wl, command);

}

arg_display()
{

    /* just return; display does the right thing */

}

/* a common prompt routine */
static void
common(string, wl, command)

char *string;
struct wordlist *wl;
struct comm *command;
{

    struct wordlist *w;
    char *buf;

    if (!countargs(wl)) {
        w = outmenuprompt(string);
        if (w == NULL)
            return;
        (*command->co_func) (w);
        wl_free(w);
    }
}


wordlist *
outmenuprompt(string)
char *string;
{
    wordlist *wl;
    char buf[100], buf1[100];
    char *c;

    sprintf(buf1, "%s: ", string);
    if (SCEDfgets(buf,sizeof(buf),cp_in,buf1) == NULL)
        return (NULL);
    if ((c = strchr(buf,'\n')) != NULL)
        *c = '\0';
    wl = alloc(wordlist);
    wl->wl_word = copy(buf);
    cp_variablesubst(&wl);
    cp_bquote(&wl);
    cp_doglob(&wl);
    return (wl);
}
