/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1992 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include "ftedefs.h"
#include "inpdefs.h"
#include "iferrmsg.h"
#include "misc.h"


int
IFnewUid(ckt,newuid,olduid,suffix,type,nodedata)

GENERIC *ckt;
IFuid *newuid;
IFuid olduid;
char *suffix;
int type;
GENERIC **nodedata;
{
    char *newname;
    int error;

    if (olduid) {
        newname = (char *)
            tmalloc(sizeof(char)*(strlen(suffix)+strlen((char*)olduid)+2));
            /* 2 = '#' + '\0' */
        sprintf(newname,"%s#%s",(char*)olduid,suffix);
    }
    else {
        newname = (char *)tmalloc(sizeof(char)*
                (strlen(suffix)+1)); /* 1 = '\0' */
        sprintf(newname,"%s",suffix);
    }

    switch (type) {
        case UID_ANALYSIS:
        case UID_TASK:
        case UID_INSTANCE:
        case UID_OTHER:
        case UID_MODEL:
            error = INPinsert(&newname,
                    (INPtables *)ft_curckt->ci_symtab);
            if (error && error != E_EXISTS) return (error);
            *newuid = (IFuid) newname;
            break;

        case UID_SIGNAL:
            error = INPmkTerm(ckt,&newname,
                    (INPtables *)ft_curckt->ci_symtab,nodedata);
            if (error && error != E_EXISTS) return (error);
            *newuid = (IFuid) newname;
            return (error);

        default:
            return (E_BADPARM);
    }
    return (OK);
}
