/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1987 Thomas L. Quarles
         1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include "inpdefs.h"
#include "iferrmsg.h"
#include "misc.h"


/*ARGSUSED*/
char *
INPdomodel(ckt,image,tab)

GENERIC *ckt;
card *image;
INPtables *tab;
{

    char *modname, *token;
    char typename[8];
    char *err = (char *)NULL;
    char *line, **s;
    int  i, lev;

    line = image->line;
    INPgetTok(&line,&token,1);  /* throw away '.model' */
    txfree(token);

    INPgetTok(&line,&modname,1);
    INPinsert(&modname,tab);

    INPgetTok(&line,&token,1);
    if (!token) {
        err = (char *)tmalloc(35 + strlen(typename));
        (void)sprintf(err,".model syntax error - ignored\n");
        return (err);
    }

    for (i = 0; i < 4 && token[i]; i++) {
        typename[i] = (isupper(token[i]) ? tolower(token[i]) : token[i]);
    }
    typename[i] = '\0';
    txfree(token);

    for (i = 0; i < ft_sim->numDevices; i++) {
        s = ft_sim->devices[i]->modelKeys;
        if (s == NULL)
            continue;
        for (; *s; s++) {
            if (!strcmp(*s,typename)) {
                (void)INPfindLev(line,&lev);
                lev--;
                if (ft_sim->devices[i]->levelMask & (1 << lev)) {
                    INPmakeMod(modname,i,image);
                    return (NULL);
                }
                break;
            }
        }
    }
    err = (char *)tmalloc(35 + strlen(typename));
    (void)sprintf(err,"unknown model type %s - ignored\n",typename);
    return (err);
}
