/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1992 Stephen R. Whiteley
****************************************************************************/

    /* get input token from 'line', 
     * and return a pointer to it in 'token'
     */

#include "spice.h"
#include "inpdefs.h"
#include "iferrmsg.h"
#include "misc.h"

#define issep(c) ((c)==' '||(c)=='\t'||(c)=='='||(c)=='('||(c)==')'||(c)==',')

int
INPgetTok(line,token,gobble)

char ** line;
char ** token;
int gobble; /* eat non-whitespace trash AFTER token? */
{
    char *point;

    /* scan along throwing away garbage characters */
    for (point = *line; *point != '\0'; point++) {
        if (issep(*point)) continue;
        break;
    }

    /* mark beginning of token */
    *line = point;

    /* now find all good characters */
    for (point = *line; *point != '\0'; point++) {
        if (issep(*point)) break;
    }
    *token = (char *)tmalloc(1 + point - *line);
    if (!*token)
        return (E_NOMEM);
    (void) strncpy(*token,*line,point - *line);
    *(*token + (point - *line)) = '\0';
    *line = point;

    /* gobble garbage to next token */
    for ( ; **line != '\0'; (*line)++) {
        if (**line == ' ') continue;
        if (**line == '\t') continue;
        if ((**line == '=') && gobble) continue;
        if ((**line == ',') && gobble) continue;
        break;
    }
    /* printf("found token (%s) and rest of line (%s)\n",*token,*line); */
    return (OK);
}
