/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Thomas L. Quarles
         1992 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include "inpdefs.h"
#include "iferrmsg.h"
#include "misc.h"

INPmodel *modtab;

    /* create/lookup a 'model' entry */

int
INPmakeMod(token,type,line)

char *token;
int type;
card *line;
{
    INPmodel **i;

    for (i = &modtab; *i != (INPmodel *)NULL; i = &((*i)->INPnextModel)) {
        if (strcmp((*i)->INPmodName,token) == 0) {
            return (OK);
        }
    }
    *i = (INPmodel *)tmalloc(sizeof(INPmodel));
    if (*i == NULL) return (E_NOMEM);
    (*i)->INPmodName = token;
    (*i)->INPmodType = type;
    (*i)->INPnextModel = (INPmodel *)NULL;
    (*i)->INPmodUsed = 0;
    (*i)->INPmodLine = line;
    (*i)->INPmodfast = NULL;
    return (OK);
}
