/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1993 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include "inpdefs.h"

int
INPnumRefs(c,terms,devs,soft,hasmod)

/*
 * Find the number of nodes used by the device keyed by c, and the
 * number of devices referenced.  Also the soft flag, and whether the
 * device has a model.
 */
int c;
int *terms, *devs;
int *soft, *hasmod;
{
    int i, j;
    IFdevice *dev;

    if (isalpha(c)) {
        if (isupper(c)) c = tolower(c);

        for (i = 0; i < ft_sim->numDevices; i++) {
            dev = ft_sim->devices[i];
            for (j = 0; j < *dev->numKeys; j++) {
                if (dev->keys[j].key == c)
                    break;
            }
            if (j < *dev->numKeys) {
                if (terms) *terms = dev->keys[j].numTerms;
                if (devs) *devs = dev->keys[j].numDevs;
                if (soft) *soft = dev->keys[j].soft;
                if (hasmod) *hasmod = (dev->modelKeys ? 1 : 0);
                return (1);
            }
        }
    }
    if (terms) *terms = 0;
    if (devs) *devs = 0;
    if (soft) *soft = 0;
    if (hasmod) *hasmod = 0;
    return (0);
}
