/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1987 Thomas L. Quarles
         1992 Stephen R. Whiteley
****************************************************************************/

#include "spice.h"
#include <stdio.h>
#include "inpdefs.h"

/*
 * The first pass of the circuit parser just looks
 * for '.model' and '.table' lines.
 */

void
INPpas1(ckt,deck,tab)

GENERIC *ckt;
card *deck;
INPtables *tab;
{
    card *current;
    char *INPdomodel();
    char *thisline;

    for (current = deck; current != NULL; current = current->nextcard) {
        /* SPICE-2 keys off of the first character of the line */
        thisline = current->line;

        while (*thisline && ((*thisline == ' ') || (*thisline == '\t')))
            thisline++;

        if (*thisline == '.') {
            if (!strncmp(thisline,".table",6)) {
                current->error = INPerrCat(current->error,
                    INPtablParse(&thisline,ckt));
                continue;
            }
            if (!strncmp(thisline,".model",6)) { 
                current->error = INPerrCat(current->error,
                    INPdomodel(ckt,current,tab));
            }
        }

        /* for now, we do nothing with the other cards - just 
         * keep them in the list for pass 2 
         */
    }
}
