/*************************************************************************
 MFB graphics and miscellaneous library for protected mode MSDOS.
 Copyright (c) Stephen R. Whiteley 1992
 Author: Stephen R. Whiteley
 *************************************************************************/

#include "spice.h"
#include <stdio.h>

#ifndef MSDOS


void
cprint(clr,buf)
int clr;
char *buf;
{
    printf(buf);
    fflush(stdout);
}


char getattr()
{
    return (0);
}

#else /* MSDOS */

#include <dos.h>
#include <ctype.h>

#ifdef __STDC__
static short getpage(void);
#else
static short getpage();
#endif


void
cprint(clr,buf)

/* print buf in color clr */
int clr;
unsigned char *buf;
{
    union REGS r;

    while (*buf) {
        /* change attribute by printing space */
        r.x.bx = getpage() + clr & 0xff;
        r.x.cx = 1;
        r.x.ax = 0x0900 + ' ';
        int86(0x10,&r,&r);

        /* now print character, advance cursor */
        r.x.bx = getpage();
        r.x.ax = 0x0e00 + *buf;
        int86(0x10,&r,&r);

        /* special case, go to beginning of line */
        if (*buf == '\n') {
            r.x.bx = getpage();
            r.x.ax = 0x0e00 + '\r';
            int86(0x10,&r,&r);
        }
        buf++;
    }
}


char
getattr()

/* return the attribute at current position */
{
    union REGS r;

    r.x.bx = getpage();
    r.x.ax = 0x0800;
    int86(0x10,&r,&r);
    return (r.x.ax >> 8);
}


static short
getpage()

/* return the current display page in upper byte */
{
    union REGS r;

    r.x.ax = 0x0f00;
    int86(0x10,&r,&r);
    return (r.x.bx & 0xff00);
}

#endif
