/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: UCB CAD Group
         1992 Stephen R. Whiteley
****************************************************************************/

/* Misc things for DOS */

#ifdef MSDOS

#include "spice.h"
#include <dos.h>
#include <sys/types.h>
#include <sys/stat.h>

/*
 * Directory emulation
 */

#ifdef HAVE_DOSDIRS
#include <direct.h>

#if !__NDPC__

#include <fcntl.h>

struct dos_dir {
        char        d_name[8];
        char        d_ext[3];
        char        d_attr;
        char        d_fill[10];
        short       d_time, d_date;
        short       d_ino;
        long        d_size;
};


DIR *
opendir(path)

char *path;
{
    static int i;

    i = open(path, O_RDONLY);
    if (i == -1)
        return (NULL);
    else
        return ((DIR *) &i);
}


struct direct *
readdir(i)

DIR *i;
{
    static struct direct d;
    static struct dos_dir dd;

    if (read(*i, &dd, sizeof (struct dos_dir)) < sizeof (struct dos_dir))
        return (NULL);
    else {
            strncpy(d.d_name, dd.d_name, sizeof(dd.d_name));
            d.d_name[sizeof(dd.d_name)] = 0;
            strcat(d.d_name, ".");
            strcat(d.d_name, dd.d_ext);
            d.d_namelen = strlen(d.d_name);
            d.d_ino = dd.d_ino;
            d.d_reclen = sizeof(d);        /* XXX */
        return (&d);
    }
}


void
closedir(i)

DIR *i;
{
    (void) close (*i);
    return;
}

#else


DIR *
opendir(dir)

char *dir;
{
    struct find_t *d;
    char buf[128];

    strcpy(buf,dir);
    if (*buf == '\\' && *(buf+1) == '\0')
        strcat(buf,"*.*");
    else
        strcat(buf,"\\*.*");

    d = (struct find_t *) malloc(sizeof(struct find_t));
    if (d == NULL) return NULL;
    if (findfirst(buf,d,0x1f)) {
        free(d);
        return (NULL);
    }
    return ((DIR *) d);
}


struct direct *
readdir(d)

DIR *d;
{
    char *c;
    static struct direct dd;
    int i;

    if (d == NULL) return NULL;
    strcpy(dd.d_name,((struct find_t *)d)->name);

    for (c = dd.d_name; *c; c++)
        if (isupper(*c)) *c = tolower(*c);

    if (findnext((struct find_t *)d))
        return (NULL);
    return (&dd);
}


void
closedir(d)

DIR *d;
{
    if (d)
        free(d);
}

#endif
#endif /* HAVE_DOSDIRS */


/****************************************************************************/
#if __NDPC__
/* fopen() broken, fix in wp.c plot5.c hplaser.c */
/* vsprintf broken also */
FILE *
ndp_fopen(file,mode)
char *file, *mode;
{
    FILE *fp;

    if (mode[1] == 'b') {
        _pmode = 0x8000;
        fp = fopen(file,mode);
        _pmode = 0x4000;
    }
    else
        fp = fopen(file,mode);
    return (fp);
}
#define fopen ndp_fopen
#endif


int
dos_tics()
/* read tic count directly */
{
    int tics = 0;
#if __NDPC__
    blk_mb(&tics,0x34,0x046c,4);
#else
#if __GNUC__
    tics = *(long*)(0xe000046c);
#endif
#endif
    return (tics);
}


/****************************************************************************/
#ifdef __GNUC__
unsigned int
_memavl()
{
    return (_go32_dpmi_remaining_virtual_memory());
}
#endif  

#else
int dos_dummy_int;  /* define something to keep linkers happy */
#endif
