/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1987 Wayne A. Christopher
         1992 Stephen R. Whiteley
****************************************************************************/

/* Print a number in a reasonable form.  This is the sort of thing that
 * %G does, but more appropriate for spice.  Returns static data.
 */

#include "spice.h"
#include "misc.h"

int cp_numdgt = -1;


char *
fixxp2(str)

/* use two digit exponent if possible */
char *str;
{
    char *ss;
    int xp;

    ss = strchr(str,'e');
    if (!ss) ss = strchr(str,'E');
    if (!ss) return (str);
    ss++;
    xp = atoi(ss);

    if (xp > 99) return str;
    if (xp < -99) return str;

    if (xp < 0)    {
        *ss = '-';
        xp = -xp;
    }
    else
        *ss = '+';
    *(ss+1) = '0' + (xp/10);
    *(ss+2) = '0' + (xp%10);
    *(ss+3) = '\0';
    if (*str == '+')
        *str = ' ';
    return (str);
}


char *
ecvt_n(d,n)

/* format: %.ne, with 2 exponent digits
 * used in agraf.c and printnum()
 */
double d;
int n;
{
    static char s[32];

    sprintf(s,"%+.*e",n,d);
    return (fixxp2(s));
}


char *
printnum(num)

double num;
{
    static char buf[128];
    int n;

    if (cp_numdgt > 1)
        n = cp_numdgt;
    else
        n = 6;
    return (ecvt_n(num,n));
}



