/***************************************************************************
JSPICE3 adaptation of Spice3e2 - Copyright (c) Stephen R. Whiteley 1992
Copyright 1990 Regents of the University of California.  All rights reserved.
Authors: 1985 Wayne A. Christopher
         1992 Stephen R. Whiteley
****************************************************************************/

/*
 * Circuit debugging commands.
 */

#include <stdio.h>
#include "spice.h"
#include "ftedefs.h"
#include "ftedebug.h"
#include "spfteext.h"

/* ARGSUSED */
void
com_state(wl)

wordlist *wl;
{
    if (!ft_curckt) {
        fprintf(cp_err, "Error: no circuit loaded.\n");
        return;
    }
    out_printf("Current circuit: %s\n", ft_curckt->ci_name);
    if (!ft_curckt->ci_inprogress) {
        out_printf("No run in progress.\n");
        return;
    }
    out_printf("Type of run: %s\n", plot_cur->pl_name);
    out_printf("Number of points so far: %d\n",
            plot_cur->pl_scale->v_length);
    out_printf("(That's all this command does so far)\n");
    return;
}

/* ARGSUSED */
void
com_dump(wl)

wordlist *wl;
{
    FILE *fp;

    if (!ft_curckt || !ft_curckt->ci_ckt) {
        fprintf(cp_err, "Error: no circuit loaded.\n");
        return;
    }
    NIprint(ft_curckt->ci_ckt);
    return;
}
